* libfi2_asm: a C library for FileInfo II (c) 1998-1999 Thierry Godefroy.

          section   TEXT
          comment   C68 libfi2_a v1.20 (position independent)

          xdef      _fi2_info
          xdef      _fi2_call
          xdef      _fi2_actn
          xdef      _fi2_scan
          xdef      _fi2_parm
          xdef      _fi2_allp
          xdef      _fi2_free
          xdef      _fi2_data
          xdef      _fi2_make
          xdef      _fi2_link
          xdef      _fi2_unlk
          xdef      _fi2_load
          xdef      _fi2_save
          xdef      _fi2_hctl
          xdef      _fi2_hmax
          xdef      _fi2_hclr
          xdef      _fi2_hget
          xdef      _fi2_hmnu
          xdef      _fi2_redo
          xdef      _fi2_htdy
          xdef      _fi2_thrd

PARAMARK1 equ       '<<%F'                        | Additionnal parameter
PARAMARK2 equ       'I2>>'                        |  marker.
MAGIC     equ       $4AFB                         Magic word.

* Prototype: int fi2_info(FI2INFO_t * fi2);

_fi2_info MOVEM.L   D3/A2/A4,-(SP)                Save the context.
          MOVE.L    #'INFO',D2                    Extension to be used.
          BSR       USEFI2EXT                     Use it.
          BNE.S     FI2INFO1                      If error, return.
          JSR       (A4)                          Call the extension.
          BNE.S     FI2INFO2                      If error, return.
          MOVEA.L   16(SP),A2                     Address of FI2INFO structure.
          MOVE.L    D1,(A2)+                      Store the database Id.
          CLR.W     (A2)+                         End of string marker+aligment.
          MOVE.L    D3,(A2)+                      Store the thing version.
          ADDQ.L    #2,A0                         Jump over the length word.
          MOVE.L    A0,(A2)                       Store pointer on copyright.
FI2INFO2  BSR       FREFI2EXT                     Free the thing.
FI2INFO1  MOVEM.L   (SP)+,D3/A2/A4                Restore the context.
          RTS                                     Return to calling function.

* Prototype: int fi2_call(chanid_t con_id, int key, char * filename);

_fi2_call MOVEM.L   D3/D4/A2-A4,-(SP)             Save the context.
          LEA       24(SP),A3                     Pointer on first parameter.
          MOVEA.L   8(A3),A1                      Filename address (C string).
          BSR       C2QDOS                        Turn C string into a QDOS one.
          BNE.S     FI2CALL1                      If error, return now.
          MOVE.L    A0,D4                         Save filename address.
          MOVEA.L   A0,A2                         Save filename address.
          MOVE.W    (A0)+,D0                      Filename length.
          MOVE.W    D0,D2                         Save it.
          BRA.S     FI2CALL3                      Start search for <<%FI2>>.
FI2CALL4  CMPI.L    #PARAMARK1,(A0)               Parameter marker (part 1) ?
          BNE.S     FI2CALL5                      If no, then jump over...
          CMPI.L    #PARAMARK2,4(A0)              Parameter marker (part 2) ?
          BNE.S     FI2CALL5                      If no, then jump over...
          MOVE.W    #MAGIC,(A0)                   Store the magic word.
          MOVE.L    A0,D1                         | Compute the true length of
          SUB.L     A2,D1                         |  the filename.
          SUBQ.L    #2,D1                         |
          SUB.W     D1,D2                         Substract it from total length
          SUBQ.W    #8,D2                         Substract length of "<<%FI2>>"
          MOVE.W    D2,6(A0)                      Store the parameter length.
          CMPI.B    #' ',-1(A0)                   Is there a padding space ?
          BNE.S     FI2CALL6                      If no, then jump over...
          SUBQ.L    #1,D1                         Do not count this space.
FI2CALL6  MOVE.W    D1,(A2)                       Store filename actual length.
          BRA.S     FI2CALL7                      Parameter processed...
FI2CALL5  ADDQ.L    #2,A0                         | Go two characters forward
          SUBQ.W    #1,D0                         |  and check again until the
FI2CALL3  DBMI      D0,FI2CALL4                   |  end of the string.
FI2CALL7  MOVE.L    #'CALL',D2                    Extension to be used.
          BSR       USEFI2EXT                     Use it.
          MOVEA.L   D4,A0                         Restore filename address.
          BEQ.S     FI2CALL2                      If no error, jump over.
          BSR       FREE_STR                      Free the filename heap space.
          BRA.S     FI2CALL1                      And return.
FI2CALL2  MOVE.L    (A3)+,D1                      Console channel Id (or -1).
          MOVE.L    (A3),D3                       Key.
          JSR       (A4)                          Call the extension.
          BSR       FREE_STR                      Free the filename heap space.
          BSR       FREFI2EXT                     Free the extension thing.
FI2CALL1  MOVEM.L   (SP)+,D3/D4/A2-A4             Restore the context.
          RTS                                     Return to calling function.

* Prototype: int fi2_actn(char * filename, short * actions, void ** act_array);

_fi2_actn MOVEM.L   D3/A2-A4,-(SP)                Save the context.
          MOVE.L    #'ACTN',D2                    Extension to be used.
          BSR       USEFI2EXT                     Use it.
          BNE.S     FI2ACTN1                      If error, return now.
          MOVEA.L   20(SP),A1                     Address of "filename".
          BSR       C2QDOS                        Convert it into a QDOS string.
          BNE.S     FI2ACTN2                      If error, return now.
          MOVEQ     #-1,D2                        Mandatory.
          JSR       (A4)                          Call the extension.
          BNE.S     FI2ACTN3                      If error, return now.
          LEA       24(SP),A2                     Pointer on second parameter.
          MOVEA.L   (A2)+,A4                      Pointer on "actions" variable.
          MOVE.W    D2,(A4)                       Store the number of actions.
          MOVEA.L   (A2),A4                       Pointer on "array" variable.
          MOVE.L    A1,(A4)                       Store the array address in it.
FI2ACTN3  BSR       FREE_STR                      Free the filename heap space.
FI2ACTN2  BSR       FREFI2EXT                     Free the extension thing.
FI2ACTN1  MOVEM.L   (SP)+,D3/A2-A4                Restore the context.
          RTS                                     Return to calling function.

* Prototype: int fi2_scan(char * next_ext, short * actions, \
*                         char * next, int flag, void ** act_array);

_fi2_scan MOVEM.L   D3/A2/A4,-(SP)                Save the context.
          MOVE.L    #'SCAN',D2                    Extension to be used.
          BSR       USEFI2EXT                     Use it.
          BNE.S     FI2SCAN1                      If error, return now.
          LEA       16(SP),A2                     Pointer on first parameter.
          MOVEA.L   (A2),A1                       Address of ext name (C str).
          BSR       GETEXT                        Put the ext into D1.L.
          BNE.S     FI2SCAN2                      If error, return now.
          MOVE.L    12(A2),D2                     Get the flag value.
          JSR       (A4)                          Call the extension.
          BNE.S     FI2SCAN2                      If error, return now.
          MOVEA.L   4(A2),A0                      Address of "actions" variable.
          MOVE.W    D2,(A0)                       Store the number of actions.
          TST.L     12(A2)                        Was the flag set ?
          BEQ.S     FI2SCAN5                      If not, jump over...
          MOVEA.L   16(A2),A0                     Address of "array" variable.
          MOVE.L    A1,(A0)                       Store address of the array.
FI2SCAN5  MOVEA.L   8(A2),A0                      Address of "next" string.
          MOVEQ     #3,D2                         Four chars max for next ext.
FI2SCAN7  ROL.L     #8,D1                         Put next ext char into LSB.
          TST.B     D1                            Is there a char ?
          BEQ.S     FI2SCAN6                      If no, jump over...
          MOVE.B    D1,(A0)+                      Store char into "next" str.
FI2SCAN6  DBRA      D2,FI2SCAN7                   Repeat with next char.
          CLR.B     (A0)                          End of "next" string.
FI2SCAN2  BSR       FREFI2EXT                     Free the extension thing.
FI2SCAN1  MOVEM.L   (SP)+,D3/A2/A4                Restore the context.
          RTS                                     Return to calling function.

* Prototype: int fi2_parm(void * act_array, int param_code, int act_idx, \
*                         short * act_type, unsigned short * act_flags, \
*                         char * act_param);

_fi2_parm MOVEM.L   D3/A2/A4,-(SP)                Save the context.
          MOVE.L    #'PARM',D2                    Extension to be used.
          BSR       USEFI2EXT                     Use it.
          BNE.S     FI2PARM1                      If error, return now.
          LEA       16(SP),A0                     Pointer on first parameter.
          MOVEA.L   (A0)+,A1                      Pointer on the array.
          MOVE.L    (A0)+,D1                      Code for requested parameter.
          MOVE.L    (A0)+,D2                      Index of considered action.
          JSR       (A4)                          Call the extension.
          BNE.S     FI2PARM2                      If error, return now.
          MOVEA.L   4(A0),A4                      Pointer on act_flags variable.
          MOVE.W    D3,(A4)                       Store the action flags.
          SWAP      D3                            Action type in LSW.
          MOVEA.L   (A0),A4                       Pointer on act_type variable.
          MOVE.W    D3,(A4)                       Store the action type.
          MOVEA.L   8(A0),A4                      Pointer on "act_param" string.
          MOVE.W    (A2)+,D1                      Chars number of parameter.
          BRA.S     FI2PARM3                      Start to transfer characters.
FI2PARM4  MOVE.B    (A2)+,(A4)+                   Copy on character.
FI2PARM3  DBRA      D1,FI2PARM4                   And repeat for all characters.
          CLR.B     (A4)                          Put the ending 0.
FI2PARM2  BSR       FREFI2EXT                     Free the extension thing.
FI2PARM1  MOVEM.L   (SP)+,D3/A2/A4                Restore the context.
          RTS                                     Return to calling function.

* Prototype: int fi2_allp(void * act_array, int act_idx,\
*                         FI2ACTION_t * act_bloc);

_fi2_allp MOVEM.L   D3/A2/A4,-(SP)                Save the context.
          MOVE.L    #'PARM',D2                    Extension to be used.
          BSR       USEFI2EXT                     Use it.
          BNE.S     FI2ALLP1                      If error, return now.
          LEA       16(SP),A0                     Pointer on first parameter.
          MOVEA.L   (A0)+,A1                      Pointer on the array.
          MOVE.L    (A0)+,D2                      Index of considered action.
          MOVEQ     #5,D1                         Code to get action name.
          JSR       (A4)                          Call the extension.
          BNE.S     FI2ALLP2                      If error, return now.
          MOVEA.L   (A0),A0                       Address of act_bloc structure.
          MOVE.L    D3,(A0)+                      Store action type and flags.
          MOVE.L    A2,(A0)+                      Store the action name address.
          MOVEQ     #4,D1                         Code for mandat./forbid. job.
          JSR       (A4)                          Call the extension.
          BNE.S     FI2ALLP2                      If error, return now.
          MOVE.L    A2,(A0)+                      Store mand/forb job name addr.
          MOVEQ     #0,D1                         Code for thing/job name.
          JSR       (A4)                          Call the extension.
          BNE.S     FI2ALLP2                      If error, return now.
          MOVE.L    A2,(A0)+                      Store the thing/job name addr.
          MOVEQ     #1,D1                         Code for executable file name.
          JSR       (A4)                          Call the extension.
          BNE.S     FI2ALLP2                      If error, return now.
          MOVE.L    A2,(A0)+                      Store exec file name address.
          MOVEQ     #3,D1                         Code for the command string.
          JSR       (A4)                          Call the extension.
          BNE.S     FI2ALLP2                      If error, return now.
          MOVE.L    A2,(A0)                       Store the command string addr.
FI2ALLP2  BSR       FREFI2EXT                     Free the extension thing.
FI2ALLP1  MOVEM.L   (SP)+,D3/A2/A4                Restore the context.
          RTS                                     Return to calling function.

* Prototype: int fi2_free(void * act_array);

_fi2_free MOVEM.L   D3/A2/A4,-(SP)                Save the context.
          MOVE.L    #'FREE',D2                    Extension to be used.
          BSR       USEFI2EXT                     Use it.
          BNE.S     FI2FREE1                      If error, return now.
          MOVEA.L   16(SP),A1                     "array" pointer value.
          JSR       (A4)                          Call the extension.
          BSR       FREFI2EXT                     Free the extension thing.
FI2FREE1  MOVEM.L   (SP)+,D3/A2/A4                Restore the context.
          RTS                                     Return to calling function.

* Prototype: int fi2_data(void * data_bloc, void ** old_data);

_fi2_data MOVEM.L   D3/A2/A4,-(SP)                Save the context.
          MOVE.L    #'DATA',D2                    Extension to be used.
          BSR       USEFI2EXT                     Use it.
          BNE.S     FI2DATA1                      If error, return now.
          MOVEA.L   16(SP),A1                     "data_bloc" pointer value.
          JSR       (A4)                          Call the extension.
          BNE.S     FI2DATA2                      If error, return now.
          MOVEA.L   20(SP),A0                     Pointer on "old_data".
          MOVE.L    A1,(A0)                       Store data bloc address.
FI2DATA2  BSR       FREFI2EXT                     Free the extension thing.
FI2DATA1  MOVEM.L   (SP)+,D3/A2/A4                Restore the context.
          RTS                                     Return to calling function.

* Prototype: int fi2_make(char * ext, char * data_id, FI2ACTION_t * act_bloc);

_fi2_make MOVEM.L   D3/A2/A4,-(SP)                Save the context.
          MOVE.L    #'MAKE',D2                    Extension to be used.
          BSR       USEFI2EXT                     Use it.
          BNE.S     FI2MAKE1                      If error, return now.
          MOVEA.L   20(SP),A1                     Address of "data_id" string.
          BSR       GETEXT                        Get the data_id.
          BNE.S     FI2MAKE2                      If error, return now.
          MOVE.L    D1,D3                         Save the data_id.
          MOVEA.L   16(SP),A1                     Address of "ext" string.
          BSR       GETEXT                        Get the "ext" name.
          BNE.S     FI2MAKE2                      If error, return now.
          MOVEA.L   24(SP),A0                     Pointer on "bloc" structure.
          MOVEQ     #0,D2                         Pointers are absolute.
          JSR       (A4)                          Call the extension.
          BNE.S     FI2MAKE2                      If error, return now.
          MOVE.L    A1,24(A0)                     Store the new bloc address.
FI2MAKE2  BSR       FREFI2EXT                     Free the extension thing.
FI2MAKE1  MOVEM.L   (SP)+,D3/A2/A4                Restore the context.
          RTS                                     Return to calling function.

* Prototype: int fi2_link(char * ext, void * address);

_fi2_link MOVEM.L   D3/A2/A4,-(SP)                Save the context.
          MOVE.L    #'LINK',D2                    Extension to be used.
          BSR       USEFI2EXT                     Use it.
          BNE.S     FI2LINK1                      If error, return now.
          MOVEA.L   16(SP),A1                     Address of "ext" string.
          BSR       GETEXT                        Get the "ext" name.
          BNE.S     FI2LINK2                      If error, return now.
          MOVEA.L   20(SP),A1                     Get the bloc address.
          MOVEQ     #-1,D2                        Mandatory.
          JSR       (A4)                          Call the extension.
FI2LINK2  BSR       FREFI2EXT                     Free the extension thing.
FI2LINK1  MOVEM.L   (SP)+,D3/A2/A4                Restore the context.
          RTS                                     Return to calling function.

* Prototype: int fi2_unlk(char * ext);

_fi2_unlk MOVEM.L   D3/A2/A4,-(SP)                Save the context.
          MOVE.L    #'UNLK',D2                    Extension to be used.
          BSR       USEFI2EXT                     Use it.
          BNE.S     FI2UNLK1                      If error, return now.
          MOVEA.L   16(SP),A1                     Address of "ext" string.
          BSR       GETEXT                        Get the "ext" name.
          BNE.S     FI2UNLK2                      If error, return now.
          MOVEQ     #-1,D2                        Mandatory.
          JSR       (A4)                          Call the extension.
FI2UNLK2  BSR       FREFI2EXT                     Free the extension thing.
FI2UNLK1  MOVEM.L   (SP)+,D3/A2/A4                Restore the context.
          RTS                                     Return to calling function.

* Prototype: int fi2_load(chanid_t data_file, void ** data_bloc, \
*                         void ** old_data);

_fi2_load MOVEM.L   D3/A2/A4,-(SP)                Save the context.
          MOVE.L    #'LOAD',D2                    Extension to be used.
          BSR       USEFI2EXT                     Use it.
          BNE.S     FI2LOAD1                      If error, return now.
          MOVEA.L   16(SP),A0                     Channel id of data file.
          SUBA.L    A1,A1                         No imposed load address.
          MOVEQ     #-1,D2                        Mandatory.
          JSR       (A4)                          Call the extension.
          BNE.S     FI2LOAD2                      If error, return now.
          LEA       20(SP),A4                     Address of secon parameter.
          MOVEA.L   (A4)+,A0                      Ptr on "data_bloc" variable.
          MOVE.L    A1,(A0)                       Store the new address of data.
          MOVEA.L   (A4),A0                       Ptr on "old_data" variable.
          MOVE.L    A2,(A0)                       Store the old address of data.
FI2LOAD2  BSR       FREFI2EXT                     Free the extension thing.
FI2LOAD1  MOVEM.L   (SP)+,D3/A2/A4                Restore the context.
          RTS                                     Return to calling function.

* Prototype: int fi2_save(chanid_t dest_file, int save_key);

_fi2_save MOVEM.L   D3/A2/A4,-(SP)                Save the context.
          MOVE.L    #'SAVE',D2                    Extension to be used.
          BSR       USEFI2EXT                     Use it.
          BNE.S     FI2SAVE1                      If error, return now.
          MOVEA.L   16(SP),A0                     Channel id of data file.
          MOVE.L    20(SP),D2                     Get the save key.
          JSR       (A4)                          Call the extension.
          BSR       FREFI2EXT                     Free the extension thing.
FI2SAVE1  MOVEM.L   (SP)+,D3/A2/A4                Restore the context.
          RTS                                     Return to calling function.

* Prototype: int fi2_hctl(short * flags);

_fi2_hctl MOVEM.L   D3/A2/A4,-(SP)                Save the context.
          MOVE.L    #'HCTL',D2                    Extension to be used.
          BSR       USEFI2EXT                     Use it.
          BNE.S     FI2HCTL1                      If error, return now.
          MOVEA.L   16(SP),A0                     Pointer on "flags" variable.
          MOVE.W    (A0),D1                       Get "flags" value.
          JSR       (A4)                          Call the extension.
          BNE.S     FI2HCTL2                      If error, return now.
          MOVE.W    D1,(A0)                       Store the returned value.
FI2HCTL2  BSR       FREFI2EXT                     Free the extension thing.
FI2HCTL1  MOVEM.L   (SP)+,D3/A2/A4                Restore the context.
          RTS                                     Return to calling function.

* Prototype: int fi2_hmax(short * records);

_fi2_hmax MOVEM.L   D3/A2/A4,-(SP)                Save the context.
          MOVE.L    #'HMAX',D2                    Extension to be used.
          BSR       USEFI2EXT                     Use it.
          BNE.S     FI2HMAX1                      If error, return now.
          MOVEA.L   16(SP),A0                     Pointer on "records" variable.
          MOVE.W    (A0),D1                       Get "records" value.
          JSR       (A4)                          Call the extension.
          BNE.S     FI2HMAX2                      If error, return now.
          MOVE.W    D1,(A0)                       Store the returned value.
FI2HMAX2  BSR       FREFI2EXT                     Free the extension thing.
FI2HMAX1  MOVEM.L   (SP)+,D3/A2/A4                Restore the context.
          RTS                                     Return to calling function.

* Prototype: int fi2_hclr(void);

_fi2_hclr MOVEM.L   D3/A2/A4,-(SP)                Save the context.
          MOVE.L    #'HCLR',D2                    Extension to be used.
          BSR       USEFI2EXT                     Use it.
          BNE.S     FI2HCLR1                      If error, return now.
          MOVEQ     #-1,D2                        Mandatory.
          JSR       (A4)                          Call the extension.
          BSR       FREFI2EXT                     Free the extension thing.
FI2HCLR1  MOVEM.L   (SP)+,D3/A2/A4                Restore the context.
          RTS                                     Return to calling function.

* Prototype: int fi2_hget(int param_code, short * record_number, \
*                         char * record_param);

_fi2_hget MOVEM.L   D3/A2/A4,-(SP)                Save the context.
          MOVE.L    #'HGET',D2                    Extension to be used.
          BSR       USEFI2EXT                     Use it.
          BNE.S     FI2HGET1                      If error, return now.
          LEA       16(SP),A2                     Pointer on first parameter.
          MOVE.L    (A2)+,D1                      Get "param_code" value.
          MOVEA.L   (A2)+,A0                      Pointer on "record_number".
          MOVE.W    (A0),D2                       Get "record_number" value.
          JSR       (A4)                          Call the extension.
          BNE.S     FI2HGET2                      If error, return now.
          TST.L     D1                            Was D1 = 0 ?
          BNE.S     FI2HGET3                      If no, jump over...
          MOVE.W    D3,(A0)                       Store record_number value.
          BRA.S     FI2HGET2                      And return.
FI2HGET3  MOVE.W    (A1)+,D1                      Number of characters.
          MOVEA.L   (A2),A0                       Pointer on "record_param" str.
          BRA.S     FI2HGET4                      Start to copy the string.
FI2HGET5  MOVE.B    (A1)+,(A0)+                   Copy a character.
FI2HGET4  DBRA      D1,FI2HGET5                   Repeat for the whole string.
          CLR.B     (A0)                          Put the ending 0.
FI2HGET2  BSR       FREFI2EXT                     Free the extension thing.
FI2HGET1  MOVEM.L   (SP)+,D3/A2/A4                Restore the context.
          RTS                                     Return to calling function.

* Prototype: int fi2_hmnu(short * record_number);

_fi2_hmnu MOVEM.L   D3/A2/A4,-(SP)                Save the context.
          MOVE.L    #'HMNU',D2                    Extension to be used.
          BSR       USEFI2EXT                     Use it.
          BNE.S     FI2HMNU1                      If error, return now.
          MOVEQ     #-1,D2                        Mandatory.
          JSR       (A4)                          Call the extension.
          BNE.S     FI2HMNU2                      If error, return now.
          MOVEA.L   16(SP),A0                     Pointer on "record_number".
          MOVE.W    D2,(A0)                       Store the returned value.
FI2HMNU2  BSR       FREFI2EXT                     Free the extension thing.
FI2HMNU1  MOVEM.L   (SP)+,D3/A2/A4                Restore the context.
          RTS                                     Return to calling function.

* Prototype: int fi2_redo(chanid_t con_id, int key, short record_number);

_fi2_redo MOVEM.L   D3/A2-A4,-(SP)                Save the context.
          MOVE.L    #'REDO',D2                    Extension to be used.
          BSR       USEFI2EXT                     Use it.
          BNE.S     FI2REDO1                      If error, return now.
          LEA       20(SP),A2                     Pointer on first parameter.
          MOVE.L    (A2)+,D1                      Get the console Id.
          MOVE.L    (A2)+,D3                      Get the key.
          MOVE.W    (A2),D2                       Get the record number.
          JSR       (A4)                          Call the extension.
          BSR       FREFI2EXT                     Free the extension thing.
FI2REDO1  MOVEM.L   (SP)+,D3/A2-A4                Restore the context.
          RTS                                     Return to calling function.

* Prototype: int fi2_htdy(void);

_fi2_htdy MOVEM.L   D3/A2/A4,-(SP)                Save the context.
          MOVE.L    #'HTDY',D2                    Extension to be used.
          BSR       USEFI2EXT                     Use it.
          BNE.S     FI2HTDY1                      If error, return now.
          MOVEQ     #-1,D2                        Mandatory.
          JSR       (A4)                          Call the extension.
          BSR       FREFI2EXT                     Free the extension thing.
FI2HTDY1  MOVEM.L   (SP)+,D3/A2/A4                Restore the context.
          RTS                                     Return to calling function.

* Prototype: int fi2_thrd(chanid_t con_id, timeout_t delay, int priority, \
*                         char * command_string);

_fi2_thrd MOVEM.L   D3/A2/A4,-(SP)                Save the context.
          MOVE.L    #'THRD',D2                    Extension to be used.
          BSR       USEFI2EXT                     Use it.
          BNE.S     FI2THRD1                      If error, return.
          LEA       16(SP),A2                     Pointer on first parameter.
          MOVEA.L   10(A2),A1                     Pointer on C string.
          BSR.S     C2QDOS                        Convert it to a QDOS string.
          BNE.S     FI2THRD2                      If error, return.
          MOVE.L    (A2)+,D1                      Console channel Id.
          MOVE.W    (A2)+,D3                      Timeout.
          MOVE.L    (A2),D2                       Priority.
          JSR       (A4)                          Call the extension.
          BSR.S     FREE_STR                      Free the string heap space.
FI2THRD2  BSR.S     FREFI2EXT                     Free the extension thing.
FI2THRD1  MOVEM.L   (SP)+,D3/A2/A4                Restore the context.
          RTS                                     Return to calling function.

* This sub-routine gets an extension from a C string (pointed to by A1) and puts
* it into D1.L. The C string is checked for more than 4 characters (extension
* size limit) and a bad parameter error is returned if so.
* Modified registers: D0, D1, A1.

GETEXT    MOVEQ     #0,D1                         Extension name storage.
          MOVEQ     #3,D0                         Four characters maximum.
GETEXT1   LSL.L     #8,D1                         Make room for a new char.
          MOVE.B    (A1)+,D1                      Store the character.
          DBEQ      D0,GETEXT1                    Repeat until end of str or 4c.
          BNE.S     GETEXT4                       If >= 4 chars, jump.
          LSR.L     #8,D1                         Get rid of the NULL char.
          BRA.S     GETEXT2                       Return without error.
GETEXT4   MOVEQ     #-15,D0                       Bad parameter error code.
          TST.B     (A1)                          Is there another character ?
          BNE.S     GETEXT3                       If yes, return with error.
GETEXT2   MOVEQ     #0,D0                         No error.
GETEXT3   TST.L     D0                            Set CCR accordingly to error.
          RTS                                     Return.

* This sub-routine converts a C string (pointed to by A1) into a QDOS string
* (which address is returned in A0). Note that it will allocate some memory
* into the heap (you will then have to de-allocate this memory once the QDOS
* string has been used). If the C string cannot fit into a QDOS string (more
* than 32764 characters), the routine returns with a "buffer full" error code.
* Modified registers: D0, D1, A0.

C2QDOS    MOVEQ     #2,D1                         Two bytes for the length word.
          MOVEA.L   A1,A0                         Copy C string address.
C2QDOS1   ADDQ.L    #1,D1                         One more character in string.
          TST.B     (A0)+                         Is it the end of the string ?
          BNE.S     C2QDOS1                       If not, repeat with next char.
          MOVEQ     #-5,D0                        Buffer full error code.
          CMPI.L    #32767,D1                     String length < 32765 bytes ?
          BPL.S     C2QDOS2                       If not, return with error.
          MOVEM.L   D1-D3/A1-A3,-(SP)             Save the context.
          BCLR      #0,D1                         Make D1 even.
          MOVEQ     #-1,D2                        Allocate for current job.
          MOVEQ     #$18,D0                       | Allocates D1 bytes into
          TRAP      #1                            |  the common heap.
          MOVEM.L   (SP)+,D1-D3/A1-A3             Restore the context.
          TST.L     D0                            Any error ?
          BNE.S     C2QDOS2                       If yes, return now.
          SUBQ.W    #3,D1                         Actual number of bytes in str.
          MOVE.W    D1,(A0)                       Store the length.
          BRA.S     C2QDOS4                       Start string copy.
C2QDOS3   MOVE.B    0(A1,D1.W),2(A0,D1.W)         Copy one character...
C2QDOS4   DBRA      D1,C2QDOS3                    ... until end of str.
C2QDOS2   TST.L     D0                            Set CCR accordingly to error.
          RTS                                     Return.

* This sub-routine de-allocate a heap space which address is held into A0.
* Modified registers: D1 to D3, A0 to A3.

FREE_STR  MOVE.L    D0,-(SP)                      Save the error code.
          MOVEQ     #$19,D0                       | Free the memory reserved for
          TRAP      #1                            |  the filename by C2QDOS.
          MOVE.L    (SP)+,D0                      Restore the error code.
          RTS                                     Return.

* This sub-routine is to be called to use the "FileInfo II extensions" thing.
* It needs the extension Id in D2.L and returns the corresponding vector into
* A4. An error may be returned if the thing system is absent or if the thing
* is not found.
* Modified registers: D0 to D3, A0 to A2, A4.

USEFI2EXT LEA       FI2EXT,A0                     Thing name.
          BSR.S     USE_THING                     Use it.
          BNE.S     C2QDOS2                       If error, return now.
          LEA       $18(A1),A4                    Vector for the extension.
          TST.L     D0                            Set CCR accordingly to error.
          RTS                                     Return.

* This sub-routine is to be called to free the "FileInfo II extensions" thing.
* Modified registers: D1, D2, A0, A2.

FREFI2EXT MOVE.L    D0,-(SP)                      Keep previous error code.
          LEA       FI2EXT,A0                     Thing name.
          BSR.S     FREE_THG                      Free it.
          MOVE.L    (SP)+,D0                      Restore code and set CCR.
          RTS                                     Return.

FI2EXT    dc.w      22
          dc.b      'FileInfo II extensions'

********************************************************************************
* Routines d'utilisation et de libration d'une chose:
* ===================================================
*
* Paramtres en entre: D0.L = $28 ou $29 (si appel de DO_THING),
* ~~~~~~~~~~~~~~~~~~~~  D1.L = Id du job concern (si appel de USE_THG),
*                       D2.L = Paramtre supplmentaire ventuel (selon chose),
*                       D3.L = Paramtre supplmentaire ventuel (si FREE_THG),
*                       A0.L = Pointeur sur le nom de la chose,
*                       A1.L = Paramtre supplmentaire ventuel (FREE_THG),
*                       A2.L = Paramtre supplmentaire ventuel (selon chose),
*
* Paramtres en sortie: D0.L = Code d'erreur,
* ~~~~~~~~~~~~~~~~~~~~  D1.L = Id du job concern (ou -1 si appel de FREE_THG),
*                       D2.L = Rsultat (selon la chose),
*                       D3.L = Version de la chose (si SMS.UTHG) ou prserv,
*                       D4.L  D7.L: prservs,
*                       A1.L = Pointeur sur la chose (si SMS.UTHG) ou prserv,
*                       A2.L = Ptr/bloc chanage chose (si SMS.UTHG) ou rsultat
*                       A0.L, A3.L  A7.L: prservs.

FREE_THG  MOVEQ     #-1,D1                        Job utilisateur=job courant.
          MOVEQ     #$29,D0                       Code pour appel  SMS.FTHG.
          BRA.S     DO_THG

USE_THING MOVEQ     #-1,D1                        Job utilisateur=job courant.
USE_THG   MOVEQ     #$28,D0                       Code pour appel  SMS.UTHG.
DO_THING  MOVEQ     #-1,D3                        Temporisation infinie.
DO_THG    MOVE.L    A4,-(SP)                      | Sauvegarder le contexte.
          MOVEM.L   D0/A0,-(SP)                   |
          BSR.S     SEARCH                        Chercher le vecteur "THING".
          MOVEM.L   (SP)+,D0/A0                   Restaurer ptr nom est code.
          BNE.S     DONE1                         Si erreur pas d'appel.
          JSR       (A4)                          Appel au vecteur "THING".
DONE1     MOVEA.L   (SP)+,A4                      Restaurer contexte.
          CMPI.L    #-7,D0                        Erreur "not found" ?
          BNE.S     DONE2                         Si non, sauter ce qui suit...
          MOVEQ     #-19,D0                       Code erreur "not implemented".
DONE2     TST.L     D0                            Positionner CCR.
          RTS                                     Retour.

********************************************************************************
* Routine de recherche de la chose "THING":
* ========================================
*
* Paramtres en entre: nant
* ~~~~~~~~~~~~~~~~~~~~
* Paramtres en sortie: A0.L=Adresse de "THING" (si D0=0),
* ~~~~~~~~~~~~~~~~~~~~  A4.L=Adresse de la routine "TH_ENTRY",
*                       D0.L=Code erreur (0: pas d'erreur, -19: non implment),
*
* Registres modifis  : D0, A0, A4.
* ~~~~~~~~~~~~~~~~~~

SEARCH    MOVEM.L   D1/D2,-(SP)                   Sauver le contexte.
          MOVEQ     #0,D0                         | Prendre les informations
          TRAP      #1                            | sur le systme.
          MOVEQ     #-19,D0                       Code erreur "non implment".
          LEA       $B8(A0),A0                    Pointeur sur liste des choses.
          MOVE.L    A0,D1                         Pointeur nul ?
          BEQ.S     SEARCH3                       Si oui, retour (pas de chose).
SEARCH1   MOVE.L    (A0),D1                       D1=Adresse du linkage block.
          BEQ.S     SEARCH2                       Si dernire chose, fin
          MOVEA.L   D1,A0                         | sinon poursuivre la recher-
          BRA.S     SEARCH1                       | che avec la chose suivante.
SEARCH2   MOVEA.L   16(A0),A0                     Pointeur sur chose elle-mme.
          CMPI.L    #'THG%',(A0)                  Est-ce bien une chose ?
          BNE.S     SEARCH3                       Si non, retour avec erreur.
          CMPI.L    #-1,4(A0)                     Est-ce la chose "THING" ?
          BNE.S     SEARCH3                       Si non, retour avec erreur.
          MOVEA.L   8(A0),A4                      Prendre le vecteur TH_ENTRY.
          MOVEQ     #0,D0                         Pas d'erreur.
SEARCH3   MOVEM.L   (SP)+,D1/D2                   Restaurer le contexte.
          TST.L     D0                            Positionner CCR.
          RTS                                     Retour.

          end
